<?php

/**
 * @file
 * Administration process forms of cck_field_rename module.
 */
 
/**
 * Menu callback;
 */
 
function cck_field_rename_action() {
  $form = array();
    
  // Generate the form
  $form['cck_field_rename_action'] = array(
    '#type' => 'fieldset',
    '#weight' => -30,
    '#title' => t('Basic settings'),
    '#collapsible' => FALSE,
    '#collapsed' => FALSE    
  );
  
  $sql = " SELECT field_name FROM {content_node_field} ORDER BY field_name";
  $results = db_query($sql);
	
	while ($data = db_fetch_object($results)) {
	  $cck_fields[$data->field_name]= $data->field_name;  
	}
	
  $form['cck_field_rename_action']['cck_field_rename_source'] = array(
    '#type' => 'select',
    '#title' => t('Select CCK field'),
		'#options' => $cck_fields,
    '#default_value' => variable_get('cck_field_rename_source', ''),
  );    
  
	$form['cck_field_rename_action']['cck_field_rename_target'] = array(
    '#type' => 'textfield',
    '#title' => t('New field name'),
    '#default_value' => variable_get('cck_field_rename_target', ''),
  ); 
	
	$form['cck_field_rename_action']['cck_field_rename_process'] = array(
      '#type' => 'submit',
      '#value' => t('Rename field'),
      '#submit' => array('cck_field_rename_process'),
    );
	return $form;
  //return system_settings_form($form);
}

//Rename the selected field
function cck_field_rename_process() {
  $field_source = addslashes(strip_tags($_REQUEST['cck_field_rename_source']));
	$field_target = addslashes(strip_tags($_REQUEST['cck_field_rename_target']));
	
	if (substr($field_target,0,6) != 'field_') {
	  drupal_set_message(t("Sorry, new field name must starting with 'field_' (i.e: field_myfield)."));
		return;	
	}
	
	//get content type
	$sql = " SELECT type_name FROM {content_node_field_instance} WHERE field_name = '%s'";
	$results = db_query($sql, $field_source);
	$data = db_fetch_object($results);
	$cck_content_type = $data->type_name;
	
	//get field type
	$sql = " SELECT type FROM {content_node_field} WHERE field_name = '%s'";
	$results = db_query($sql, $field_source);
	$data = db_fetch_object($results);
	$cck_field_type = $data->type;
	
	//field
	$table_name       = 'content_type_'.$cck_content_type;
	$field_source_val = $field_source.'_value';
	$field_target_val = $field_target.'_value';
	
	if (db_column_exists($table_name, $field_source_val)) {
	  switch ($cck_field_type) {
	    case 'text':
		    db_change_field($ret, $table_name, $field_source_val, $field_target_val, 
	      array('type' => 'text', 'size' => 'big','not null' => FALSE));
			break;
		  
			case 'number_integer':
		    db_change_field($ret, $table_name, $field_source_val, $field_target_val, 
	      array('type' => 'int', 'size' => 'normal','not null' => FALSE));
			break;
		  
			case 'number_float':
		    db_change_field($ret, $table_name, $field_source_val, $field_target_val, 
	      array('type' => 'float', 'size' => 'normal','not null' => FALSE));
			break;
			
			case 'number_decimal':
		    db_change_field($ret, $table_name, $field_source_val, $field_target_val, 
	      array('type' => 'numeric', 'size' => 'normal','not null' => FALSE, 'precision' => 10,'scale' => 2 ));
			break;
			
			case 'filefield':
		    db_change_field($ret, $table_name, $field_source.'_fid', $field_target.'_fid', 
	        array('type' => 'int', 'size' => 'normal','not null' => FALSE));
				db_change_field($ret, $table_name, $field_source.'_list', $field_target.'_list', 
	        array('type' => 'int', 'size' => 'tiny','not null' => FALSE));
				db_change_field($ret, $table_name, $field_source.'_data', $field_target.'_data', 
	        array('type' => 'text', 'size' => 'normal','not null' => FALSE));
			break;
			
			default:
		    drupal_set_message(t("Field type not supported (please report this issue): $cck_field_type."));
			  return;
	  }
	}
  
	//content_node_field_instance
	$sql = " UPDATE {content_node_field_instance} SET field_name = '%s'"
	      ." WHERE field_name = '%s'";
	db_query($sql, $field_target, $field_source);
	
	//content_group_fields
	$sql = " UPDATE {content_group_fields} SET field_name = '%s'"
	      ." WHERE field_name = '%s'";
	db_query($sql, $field_target, $field_source);
	
	//content_node_field
	$sql = " UPDATE {content_node_field} SET field_name = '%s'"
	      ." WHERE field_name = '%s'";
	db_query($sql, $field_target, $field_source);
	
	db_query("TRUNCATE TABLE {cache_content}");
 	//Results
	drupal_set_message(t(
	  " Content type: $cck_content_type<br />"
	 ." Rename '$field_source' to '$field_target'"));
	
	drupal_flush_all_caches();
	
	return;
}
